/*
  RIOS provides a simple, C-based approach to providing simple 
  multitasking  functionality  in  embedded  designs.
  
  Based on the article 
  "RIOS: A Lightweight Task Scheduler for Embedded Systems" 
  https://www.ics.uci.edu/~givargis/pubs/C50.pdf

  Initiator 17.04.2017 12:45:50 Detlev Tietjen

  List of Authors
  17.4.2017 V0.1 Detlev Tietjen, initial version
  22.3.2017 V0.2 Markus        , Addaption to timer1 for usage with Arduino Uno

*/

#include "rios.h"

//#define LED_BUILTIN 13 // ARDUINO UNO
#define LED2        12 // led for second thread

threadStatus_t led1(threadStatus_t state, void * argument)
{
  digitalWrite(LED_BUILTIN, HIGH);
  delay(50);
  digitalWrite(LED_BUILTIN, LOW);
  return THREAD_STATUS_DEFAULT;
}

threadStatus_t led2(threadStatus_t state, void * argument)
{
  digitalWrite(LED2, HIGH);
  delay(500);
  digitalWrite(LED2, LOW);
  return THREAD_STATUS_DEFAULT;
}

void setup()   
{
  pinMode(LED_BUILTIN, OUTPUT);
  pinMode(LED2, OUTPUT);
  threadAdd(led1, NULL, 100/THREAD_MS_PER_TICK);
  threadAdd(led2, NULL, 1000/THREAD_MS_PER_TICK);
  threadStart();
}


void loop()    
{

}
